#ifndef Aztec2_MainWindow_Header
#define Aztec2_MainWindow_Header

#include <gui/MWindow.h>
#include <gui/MContainer.h>

#include <controls/MultiSplitter.h>
#include <controls/ChannelBar.h>

namespace AztecGUI {

  class MainWindow : public Aztec::MWindow {
  public:
    MainWindow();
    ~MainWindow();

    /**
     * Since there is only one MainWindow at any one time in an application, 
     * make it so we can get it from anywhere in the application
     */
    static MainWindow* getInstance();

    // MComponent methods
    void onCreate();

  private:
    AztecGUI::MultiSplitter *splitter;
    AztecGUI::ChannelBar *channelBar;
    Aztec::MContainer *bottomToolbar;
  };


}


#endif

