#ifndef AztecGUICommon_Colour_Constants_Header
#define AztecGUICommon_Colour_Constants_Header

#include <AztecGUICommon.h>
#include <string>

namespace AztecGUI {

  class AZTECGUI_EXPORT Colours {
  public:
    typedef enum {
      VIEW_BACKGROUND,
      VIEW_TITLE,
      VIEW_TITLE_CURRENT,
      VIEW_BORDER,
      VIEW_BORDER_CURRENT,

      GRID3D_MAJOR,
      GRID3D_MINOR,
	  GRID3D_AXIS,

      OBJECT_WIREFRAME,
      OBJECT_WIREFRAME_SELECTED,

      X_AXIS,
      Y_AXIS,
      Z_AXIS,
      SELECTED_AXIS,

      TIMESLIDER_BACKGROUND,
      TIMESLIDER_TICKMARKS,
      TIMESLIDER_TEXT,
      TIMESLIDER_CURRENT_FRAME,
      TIMESLIDER_KEY_FRAME,

      GRAPH_PLOT_LINE,
      GRAPH_KEY,
      GRAPH_KEY_SELECTED

    } Colour;

    static const char* getName(Colour colour);
    static Colour getColourIndex(const std::string &name);

  };

}




#endif

