/*

  Copyright (c) 2003 Phillip Martin
  Copyright (c) 2003 Richard van Eijbergen <richardve@users.sourceforge.net>

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  2111-1307  USA

*/

#include <AztecGUICommonPCH.h>

#include <gui/qt3/MHotKeyControlImpl.h>
#include <gui/qt3/MContainerImpl.h>
#include <gui/qt3/MAppImpl.h>

#include <assert.h>


namespace Aztec {

  MHotKeyControl::MHotKeyControl(int width)
    : MTextField(width)
  {
  }

  MHotKeyControl::~MHotKeyControl() {
  }

  //
  // Here is a sample subclass function.
  //
/*  static LONG FAR PASCAL SubClassFunc(   HWND hWnd,
                 WORD Message,
                 WORD wParam,
                 LONG lParam)
  {
    MHotKeyControlPtr field = AZTEC_CAST(MHotKeyControl, MApp::getInstance()->getComponent(hWnd));

    assert(field != NULL);

     //
     // When the focus is in an edit control inside a dialog box, the
     //  default ENTER key action will not occur.
     //
    if (Message == WM_KEYDOWN) {
      bool handled = field->handleKeyEvent(MKeyEvent(MKeyEvent::KEY_DOWN, ::GetTickCount(), field->getKeyCodeFromVK(wParam), field->getStateFromAsync(), field));
       
      if (wParam == VK_TAB || wParam == VK_RETURN) {
        HWND parent = ::GetParent(hWnd);
        HWND next = NULL;

        if (parent != NULL) {
          next = ::GetNextDlgTabItem(parent, hWnd, !(::GetAsyncKeyState(VK_SHIFT) & 0x8000));
          ::SetFocus(next);
        }

        return 0;
      } 
      if (wParam == VK_ESCAPE) {
        ::SetFocus(NULL);
      }
    } else if (Message == WM_CHAR) {
      // If we have a char message, ignore any tabs, sicne they are handled by WM_KEYDOWN

      bool handled = field->handleKeyEvent(MKeyEvent(MKeyEvent::KEY_DOWN, ::GetTickCount(), field->getKeyCodeFromVK(toupper(wParam)), field->getStateFromAsync(), field));

      if (wParam == VK_TAB || wParam == VK_RETURN || wParam == VK_ESCAPE) {
        return 0;
      }
    }  else if (Message == WM_KEYUP) {
      bool handled = field->handleKeyEvent(MKeyEvent(MKeyEvent::KEY_UP, ::GetTickCount(), field->getKeyCodeFromVK(wParam), field->getStateFromAsync(), field));
        

    } else if (Message == WM_NCPAINT) {
      // BUG: For some reason, when a region passes through this window proc, 
      // and then NC_PAINT message is handled, the control's frame isn't 
      // always redrawn. The hack is to set wParam to 1, which means the 
      // entire frame should be drawn.
      wParam = 1;
    }
    
    return CallWindowProc(field->lpfnOldWndProc, hWnd, Message, wParam, lParam);
  }
*/

  bool MHotKeyControl::createImpl() {
/*    MApp *app;
    HWND parentHWND = NULL;

    if (m_Parent != NULL) {
      parentHWND = m_Parent->getHWnd();
    }

    app = MApp::getInstance();

    m_hWnd = CreateWindowEx(0, HOTKEY_CLASS, "", WS_CHILD | ES_AUTOHSCROLL | WS_TABSTOP, 
                            0, 10, 0, 10, parentHWND, NULL, app->getHInstance(), NULL); 
    

    if (m_hWnd != 0) {
      // now subclass us
      lpfnOldWndProc = (WNDPROC)SetWindowLong(m_hWnd, GWL_WNDPROC, (DWORD) SubClassFunc);
      
      app->registerComponent(m_hWnd, this);

      ::SendMessage(m_hWnd, WM_SETFONT, (DWORD)::GetStockObject(DEFAULT_GUI_FONT), 0);

      ::SetWindowLong(m_hWnd, GWL_EXSTYLE, WS_EX_CLIENTEDGE);


      onCreate();

      setVisible(true);
      ::UpdateWindow(m_hWnd);

      return true;
    }
*/
    return false;
  }

  MKeyEvent::KeyCode MHotKeyControl::getHotKey() const {
/*    DWORD value = ::SendMessage(m_hWnd, HKM_GETHOTKEY, 0, 0);
    WORD vkCode = value & 0xFF;
    WORD modifier = (value & 0xFF00) >> 8;
    return MComponent::getKeyCodeFromVK(vkCode);*/
    return MKeyEvent::KeyCode();
  }

  MShiftState MHotKeyControl::getModifiers() const {
/*    DWORD value = ::SendMessage(m_hWnd, HKM_GETHOTKEY, 0, 0);
    WORD vkCode = value & 0xFF;
    WORD modifier = (value & 0xFF00) >> 8;
    return MShiftState(false, false, false, 
                       (modifier & HOTKEYF_ALT) != 0, 
                       (modifier & HOTKEYF_CONTROL) != 0, 
                       (modifier & HOTKEYF_SHIFT) != 0);*/
    return MShiftState(false, false, false, false, false, false);
  }

  void MHotKeyControl::setHotKey(MKeyEvent::KeyCode code, MShiftState modifiers) {
/*    int vk = MComponent::getVKFromKeyCode(code);
    int mods = (modifiers.altPressed ? HOTKEYF_ALT : 0) | 
               (modifiers.ctrlPressed ? HOTKEYF_CONTROL : 0) | 
               (modifiers.shiftPressed ? HOTKEYF_SHIFT : 0);
    ::SendMessage(m_hWnd, HKM_SETHOTKEY, MAKEWORD(vk, mods), 0);*/
  }

  void MHotKeyControl::clearHotKey() {
//    ::SendMessage(m_hWnd, HKM_SETHOTKEY, 0, 0);
  }


}

