#include <AztecGUICommonPCH.h>

#include <gui/scripting/AztecGUIScripting.h>

namespace Aztec {
 

  void initGUIClasses(JSContext *cx) {
    JSObject *componentClass = initMComponentClass(cx);

    JSObject *containerClass = initMContainerClass(cx, componentClass);
    JSObject *windowClass = initMWindowClass(cx, containerClass);
    JSObject *toolWindowClass = initMToolWindowClass(cx, windowClass);
    JSObject *scrolledClass = initMScrolledContainerClass(cx, containerClass);
    JSObject *tabbedContainerClass = initMTabbedContainerClass(cx, componentClass);

    JSObject *buttonClass = initMButtonClass(cx, componentClass);
    JSObject *textFieldClass = initMTextFieldClass(cx, componentClass);
    JSObject *labelClass = initMLabelClass(cx, componentClass);
    JSObject *sliderClass = initMSliderClass(cx, componentClass);
    JSObject *checkboxClass = initMCheckboxClass(cx, componentClass);
    JSObject *comobBoxClass = initMComboBoxClass(cx, componentClass);

    JSObject *borderLayoutClass = initMBorderLayoutClass(cx);
    JSObject *flowLayoutClass = initMFlowLayoutClass(cx);
    JSObject *gridLayoutClass = initMGridLayoutClass(cx);
    JSObject *mouseEventClass = initMMouseEventClass(cx);
    JSObject *keyEventClass = initMKeyEventClass(cx);
    JSObject *size2DClass = initMSize2DClass(cx);

  }


}
