#include "StdAfx.h"

#include <params/MArrayParameter.h>

namespace Aztec {

  int MArrayParameter::getDataType() const {
    return TYPE_ARRAY;
  }

  bool MArrayParameter::getValueString(MStr &value) {
    return false;
  }

  bool MArrayParameter::getValueInteger(int &value) {
    return false;
  }

  bool MArrayParameter::getValueFloat(float &value) {
    return false;
  }

  bool MArrayParameter::getValueBoolean(bool &value) {
    return false;
  }

  bool MArrayParameter::getValueVector(MVector3 &value) {
    return false;
  }

  bool MArrayParameter::setValueString(const MStr &value) {
    return false;
  }

  bool MArrayParameter::setValueInteger(int value) {
    return false;
  }

  bool MArrayParameter::setValueFloat(float value) {
    return false;
  }

  bool MArrayParameter::setValueBoolean(bool value) {
    return false;
  }

  bool MArrayParameter::setValueVector(const MVector3 &value) {
    return false;
  }

  // MArrayParameterAdapter
  bool MArrayParameterAdapter::setValueParameter(const MParameterObjectPtr &value) {
    MArrayParameter *array = AZTEC_CAST(MArrayParameter, value);

    // if we don't have an array, we can't exactly set the values from it, can we?
    if (array == NULL) {
      return false;
    }

    resize(array->getElementCount());

    for (int i = 0; i < getElementCount(); ++i) {
      // attempt to set the element in the array. If it fails, then
      // bail out immediately.
      ;
      if (!((MArrayParameter*)this)->getElement(i)->setFromParameter(array->getElement(i))) {
        return false;
      }
    }

    return true;
  }

}

