#ifndef KEYFUNCGENERAL_H
#define KEYFUNCGENERAL_H

#include "Keyboard.h"

void InitGeneralActionList(MActionListType *AL);


// mode functions

int KModeObject();
int KModePoint();
int KModeFace();
int KModeEdge();
int KModeCycle();

int KSeparateAxisToggle();

// Object functions
int KObjectDeleteSelected();
int KObjectDuplicateSelected();
int KObjectCentrePivot();

// Primitive Functions
int KPrimitiveCreateLight();
int KPrimitiveCreateCamera();
int KPrimitiveCreateTransform();
int KPrimitiveCreateMaterial();
int KPrimitiveCreateCluster();
int KPrimitiveCreateBone();

// Deformation Functions
int KDeformCreateCluster();
int KDeformAttachBones();
int KDeformAssignClusterWeight();

// Scene heirahcy traversal functions
int KSelectParent();
int KSelectChild();
int KSelectPrevSibling();
int KSelectNextSibling();

// Scene Heirachy Modification functions
int KParentSelection();
int KUnparentSelection();

// Material Related funtioncs
int KAssignMaterialToSelection();


#endif